package net.wanji.utc.common.exception;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import net.wanji.utc.common.BaseInfoInterface;

/**
 * @author wuxiaokai
 * @date 2022/11/21 9:38:54
 */
@Setter
@Getter
public class ControlException extends RuntimeException {
    private static final long serialVersionUID = 9081671784110014059L;

    /**
     * 错误码
     */
    protected Integer errorCode;
    /**
     * 错误信息
     */
    protected String errorMsg;

    public ControlException() {
        super();
    }

    public ControlException(BaseInfoInterface errorInfoInterface) {
        super(errorInfoInterface.getResultMsg());
        this.errorCode = errorInfoInterface.getResultCode();
        this.errorMsg = errorInfoInterface.getResultMsg();
    }

    public ControlException(BaseInfoInterface errorInfoInterface, Throwable cause) {
        super(errorInfoInterface.getResultMsg(), cause);
        this.errorCode = errorInfoInterface.getResultCode();
        this.errorMsg = errorInfoInterface.getResultMsg();
    }

    public ControlException(String errorMsg) {
        super(errorMsg);
        this.errorMsg = errorMsg;
    }

    public ControlException(Integer errorCode, String errorMsg) {
        super(errorMsg);
        this.errorCode = errorCode;
        this.errorMsg = errorMsg;
    }

    public ControlException(Integer errorCode, String errorMsg, Throwable cause) {
        super(errorMsg, cause);
        this.errorCode = errorCode;
        this.errorMsg = errorMsg;
    }

    @Override
    public Throwable fillInStackTrace() {
        return this;
    }
}
